program editor;
uses _graph,crt,mouse;
type image1 = array[0..38399] of byte;
     byteimage = ^image1;
var
  pal : palette;
  f : file;
  image : byteimage;
  ukaz : pointer;
  X,Y,I : word;
  COL,mode : byte;
  S : string;
  tx : gtext;
procedure loadimage(var f: file;var im : byteimage);
var
  head : array[1..5] of char;
  X,Y : word;
begin
  reset(f,1);
  blockread(f,head,5);
  blockread(f,X,2);
  blockread(f,Y,2);
  if (head<> 'ZMAPs') or (X<> 320) or (Y<>120) then halt;
  blockread(f,im^,38400);
  close(f);
end;
procedure saveimage(var f: file;im : byteimage);
var
  head : array[1..5] of char;
  X,Y : word;
begin
  rewrite(f,1);
  head:= 'ZMAPs';
  X:= 320; Y:= 120;
  blockwrite(f,head,5);
  blockwrite(f,X,2);
  blockwrite(f,Y,2);
  blockwrite(f,im^,38400);
  close(f);
end;
function exist(var f : file): boolean;
begin
  {$I-}
  reset(f);
  if IOResult= 0 then
    begin
      exist:= true;
      close(f);
      exit;
    end
      else exist:= false;
  {$I+}
end;
begin
  mode:= 1;
  if paramstr(1)= '' then halt;
  assign(f,'palette1.zpl');
  _initpalette(pal);
  _floadpalette(f,pal);
  getmem(image,38400);
  assign(f,paramstr(1));
  if exist(f) then loadimage(f,image)
              else fillchar(image^,38400,0);
  _initgraph;
  _loadpalette(pal);
  ukaz:= ptr($A000,$0);
  move(image^,ukaz^,38400);
  {$Q-}
  {$R-}
{  for Y:= 0 to 119 do   (* prevraceni *)
    for X:= 0 to 319 do _drawmempixel(319-X,Y,image^[Y*320+X]);{}
{  for Y:= 0 to 119 do   (* zesvetleni *)
    for X:= 0 to 319 do
      begin
        if image^[Y*320+X]= 0 then _drawmempixel(X,Y,0)
                              else _drawmempixel(X,Y,image^[Y*320+X]+2);
      end;{}
{  _settextstyle(5,tx);
  _setcolor(105);
  _outtextXY(20,100,'Orl( hr*dek',tx);
  _outtextXY(240,100,'Exit',tx);
  _unsettextstyle(tx);{}
  for Y:= 0 to 8 do
    for X:= 0 to 32 do
      begin
        _setcolor(Y*32+X);
        _bar(X*10,120+Y*10,X*10+10,120+Y*10+10);
      end;
  showpointer;
  repeat
  if Lpress then
      if MgY<120 then
        case mode of
          1 : _drawmempixel(MgX div 2,MgY,_getcolor);
          2 :
            begin
              hidepointer;
              _bar(MgX div 2-5,MgY-5,MgX div 2+5,MgY+5);
              showpointer;
            end;
          3 :
            begin
              hidepointer;
              _bar(MgX div 2-2,MgY-2,MgX div 2+2,MgY+2);
              showpointer;
            end;
        end
                 else _setcolor(_getmempixel(MgX div 2,MgY));
  if keypressed then
    case readkey of
      #27 :
        begin
          _closegraph;
          halt;
        end;
      '1' : mode:= 1;
      '2' : mode:= 2;
      '3' : mode:= 3;
    end;
  str(_getmempixel(MgX div 2,MgY),S);
  COL:= _getcolor;
  _setcolor(_getmempixel(MgX div 2,MgY));
  while S[0]<> #3 do S:= '0'+S;
  _outtextXYt(24,30,S);
  _setcolor(COL);
  until Rpress;
  {$R+}
  {$Q+}
  hidepointer;
  ukaz:= ptr($A000,$0);
  move(ukaz^,image^,38400);
  _closegraph;
  saveimage(f,image);
end.