uses _graph,mouse,crt;
var
  pal : palette;
  f : file;
  co,R,G,B,col : byte;
  X,Y : byte;
  A : char;
  S : string;
procedure _fsavepalette(var f : file;pal: palette);
var
  head : array[1..6] of char;
begin
  head:= 'ZMPpal';
  rewrite(f,1);
  blockwrite(f,head,6);
  blockwrite(f,pal^,768);
  close(f);
end;
procedure _floadpalette(var f : file;var pal: palette);
var
  head : array[1..6] of char;
begin
  reset(f,1);
  blockread(f,head,6);
  if head<> 'ZMPpal' then
    begin
      close(f);
      exit;
    end;
  blockread(f,pal^,768);
  close(f);
end;
function exist(var f : file): boolean;
begin
  {$I-}
  reset(f);
  if IOResult= 0 then
    begin
      exist:= true;
      close(f);
      exit;
    end
      else exist:= false;
  {$I+}
end;
begin
  assign(f,paramstr(1));

  if (Paramstr(1)= '') then
    begin
      writeln('POUZITI: PALETA.EXE [soubor]');
      writeln;
      writeln('Program by Ondrej Polacek, Hippo Games, 1998 ');
      halt;
    end;
  _initpalette(pal);
  if exist(f) then _floadpalette(f,pal);
  _initgraph;
  if exist(f) then _loadpalette(pal)
              else _savepalette(pal);
{  _resetscreen(0,0,0);
  for X:= 0 to 63 do _setRGBpal(X,0,X,0);
  _savepalette(pal);}
  COL:=0;
  for Y:=0 to 15 do
    for X:= 0 to 15 do
      begin
        _setcolor(COL);
        _bar(X*10,Y*10,X*10+10,Y*10+10);
        inc(COL);
      end;
   showpointer;
   co:= 1;
   repeat
   if lpress then
     begin
       _setcolor(_getmempixel(mgX div 2,mgy));
       _bar(200,10,220,30);
       _getRGBpal(_getcolor,R,G,B);
       str(R,S);
       while S[0]<> #3 do S:= '0' +S;
       _outtextXYt(21,4,S);
       str(G,S);
       while S[0]<> #3 do S:= '0' +S;
       _outtextXYt(22,4,S);
       str(B,S);
       while S[0]<> #3 do S:= '0' +S;
       _outtextXYt(23,4,S);
       str(_getcolor,S);
       while S[0]<> #3 do S:= '0' +S;
       _outtextXYt(24,4,S);
     end;
   if keypressed then
     begin
       A:= readkey;
       if A= #0 then
         begin
           A:= readkey;
           _getRGBpal(_getcolor,R,G,B);
           case A of
             #72 :
               case co of
                 1 : inc(R);
                 2 : inc(G);
                 3 : inc(B);
               end;
             #80 :
               case co of
                 1 : dec(R);
                 2 : dec(G);
                 3 : dec(B);
               end;
           end;
           _setRGBpal(_getcolor,R,G,B);
           case co of
             1 :
               begin
                 str(R,S);
                 while S[0]<> #3 do S:= '0' +S;
                 _outtextXYt(21,4,S);
               end;
             2 :
               begin
                 str(G,S);
                 while S[0]<> #3 do S:= '0' +S;
                 _outtextXYt(22,4,S);
               end;
             3 :
               begin
                 str(B,S);
                 while S[0]<> #3 do S:= '0' +S;
                 _outtextXYt(23,4,S);
               end;
           end;
         end
           else
         begin
           case A of
             '1' : co:= 1;
             '2' : co:= 2;
             '3' : co:= 3;
           end;
         end;
     end;
   until Rpress;
   _savepalette(pal);
   _fsavepalette(f,pal);
   _closegraph;
end.

